;
;  Hacker Disassembler Engine 32
;  Copyright (c) 2006-2008, Veacheslav Patkov.
;  aLL rights reserved.
;

C_NONE   EQU 00h
C_MODRM  EQU 01h
C_DATA8  EQU 02h
C_DATA16 EQU 04h
C_DATA32 EQU 08h
C_PRE66  EQU 10h
C_REL8   EQU 20h
C_REL32  EQU 40h

hde32s STRUCT
    len        BYTE ?   ; length of command
    p_rep      BYTE ?   ; rep/repz (0xf3) & repnz (0xf2) prefix
    p_lock     BYTE ?   ; lock prefix: 0xf0
    p_seg      BYTE ?   ; segment prefix: 0x2e,0x36,0x3e,0x26,0x64,0x65
    p_66       BYTE ?   ; operand-size override prefix: 0x66
    p_67       BYTE ?   ; address-size override prefix: 0x67
    opcode     BYTE ?   ; opcode
    opcode2    BYTE ?   ; second opcode (if first opcode is 0x0f)
    modrm      BYTE ?   ; ModR/M byte:
    modrm_mod  BYTE ?   ;   mod field of ModR/M
    modrm_reg  BYTE ?   ;   reg field of ModR/M
    modrm_rm   BYTE ?   ;   r/m field of ModR/M
    sib        BYTE ?   ; SIB byte:
    sib_scale  BYTE ?   ;   scale field of SIB
    sib_index  BYTE ?   ;   index field of SIB
    sib_base   BYTE ?   ;   base field of SIB
    imm8       BYTE ?   ; immediate value imm8
    imm16      WORD ?   ; immediate value imm16
    imm32      DWORD ?   ; immediate value imm32
    disp8      BYTE ?   ; displacement disp8
    disp16     WORD ?   ; displacement disp16
    disp32     DWORD ?   ; displacement disp32
    rel8       BYTE ?   ; relative address rel8
    rel16      WORD ?   ; relative address rel16
    rel32      DWORD ?   ; relative address rel32
hde32s ENDS


delta_table EQU hde_table_ext-hde_table
