IMAGE_DIRECTORY_ENTRY_EXPORT                equ  0
IMAGE_DIRECTORY_ENTRY_IMPORT                equ  1
IMAGE_DIRECTORY_ENTRY_RESOURCE              equ  2
IMAGE_DIRECTORY_ENTRY_EXCEPTION             equ  3
IMAGE_DIRECTORY_ENTRY_SECURITY              equ  4
IMAGE_DIRECTORY_ENTRY_BASERELOC             equ  5
IMAGE_DIRECTORY_ENTRY_DEBUG					equ  6
IMAGE_DIRECTORY_ENTRY_COPYRIGHT             equ  7
IMAGE_DIRECTORY_ENTRY_GLOBALPTR             equ  8
IMAGE_DIRECTORY_ENTRY_TLS					equ  9
IMAGE_DIRECTORY_ENTRY_LOAD_CONFIG           equ 10
IMAGE_DIRECTORY_ENTRY_BOUND_IMPORT          equ 11
IMAGE_DIRECTORY_ENTRY_IAT					equ 12
IMAGE_NUMBEROF_DIRECTORY_ENTRIES            equ 16

struc IMAGE_DATA_DIRECTORY
  .VirtualAresdress	resd	1
  .iSize			resd	1          
endstruc

struc IMAGE_OPTIONAL_HEADER32
  .Magic                         resw       1		;00
  .MajorLinkerVersion            resb       1		;02
  .MinorLinkerVersion            resb       1		;03
  .SizeOfCode                    resd      1			;04
  .SizeOfInitializeresdata         resd      1		;08
  .SizeOfUninitializeresdata       resd      1		;0c
  .AddressOfEntryPoint           resd      1		;10
  .BaseOfCode                    resd      1			;14
  .BaseOfData                    resd      1			;18
  .ImageBase                 	resd      1			;1c
  .SectionAlignment              resd      1			;20
  .FileAlignment                 resd      1			;24
  .MajorOperatingSystemVersion   resw       1		;28
  .MinorOperatingSystemVersion   resw       1		;2A
  .MajorImageVersion             resw       1		;2c
  .MinorImageVersion             resw       1		;2e
  .MajorSubsystemVersion         resw       1		;30
  .MinorSubsystemVersion         resw       1		;32
  .Win32VersionValue             resd      1			;34
  .SizeOfImage                   resd      1			;38
  .SizeOfHeaders                 resd      1			;3c
  .CheckSum                      resd      1			;40
  .Subsystem                     resw       1		;44
  .DllCharacteristics            resw       1		;46
  .SizeOfStackReserve            resd      1			;48
  .SizeOfStackCommit             resd      1			;4c
  .SizeOfHeapReserve             resd      1			;50
  .SizeOfHeapCommit              resd      1			;54
  .LoaderFlags                   resd      1			;58
  .NumberOfRvaAndSizes           resd      1			;5c
  ;DataDirectory00               istruc IMAGE_DATA_DIRECTORY
  ;DataDirectory01               istruc IMAGE_DATA_DIRECTORY
  ;DataDirectory02               istruc IMAGE_DATA_DIRECTORY
  ;DataDirectory03               istruc IMAGE_DATA_DIRECTORY
  ;DataDirectory04               istruc IMAGE_DATA_DIRECTORY
  ;DataDirectory05               istruc IMAGE_DATA_DIRECTORY
  ;DataDirectory06               istruc IMAGE_DATA_DIRECTORY
  ;DataDirectory07               istruc IMAGE_DATA_DIRECTORY
  ;DataDirectory08               istruc IMAGE_DATA_DIRECTORY
  ;DataDirectory09               istruc IMAGE_DATA_DIRECTORY
  ;DataDirectory0a               istruc IMAGE_DATA_DIRECTORY
  ;DataDirectory0b               istruc IMAGE_DATA_DIRECTORY
  ;DataDirectory0c               istruc IMAGE_DATA_DIRECTORY
  ;DataDirectory0d               istruc IMAGE_DATA_DIRECTORY  
  ;DataDirectory0e               istruc IMAGE_DATA_DIRECTORY
  ;DataDirectory0f               istruc IMAGE_DATA_DIRECTORY
endstruc

IMAGE_OPTIONAL_HEADER  equ  IMAGE_OPTIONAL_HEADER32

struc IMAGE_FILE_HEADER			; LENGTH(14h)
  .Machine               resw    1	; 00
  .NumberOfSections      resw    1	; 02
  .TimeDateStamp         resd   1	; 04
  .PointerToSymbolTable  resd   1	; 08
  .NumberOfSymbols       resd   1	; 0c
  .SizeOfOptionalHeader  resw    1	; 10
  .Characteristics       resw    1	; 12
endstruc

struc IMAGE_NT_HEADERS
  .Signature         resd           1
  .FileHeader		 resb			14
  .OptionalHeader	 resb			1
  ;.FileHeader        istruc IMAGE_FILE_HEADER       
  ;.OptionalHeader    e
endstruc

struc IMAGE_EXPORT_DIRECTORY
  .EXP_Characteristics           resd      1	;00
  .EXP_TimeDateStamp             resd      1 ;04
  .MajorVersion              resw       1	;08
  .MinorVersion              resw       1	;0a
  .nName                     resd      1		;0c
  .nBase                     resd      1		;10
  .NumberOfFunctions         resd      1		;14
  .NumberOfNames             resd      1		;18
  .AresdressOfFunctions        resd      1	;1c
  .AresdressOfNames            resd      1	;20
  .AresdressOfNameOrdinals     resd      1	;24
endstruc

struc IMAGE_DOS_HEADER
  .e_magic           resw      1		; 00
  .e_cblp            resw      1		; 02
  .e_cp              resw      1		; 04
  .e_crlc            resw      1		; 08
  .e_cparhdr         resw      1		; 0a
  .e_minalloc        resw      1		; 0c
  .e_maxalloc        resw      1		; 0e
  .e_ss              resw      1		; 10
  .e_sp              resw      1		; 12
  .e_csum            resw      1		; 14
  .e_ip              resw      1		; 18
  .e_cs              resw      1		; 1a
  .e_lfarlc          resw      1		; 1c
  .e_ovno            resw	  1		; 1e
  .e_res             resw	4		; 20
  .e_oemid           resw      1		; 28
  .e_oeminfo         resw      1		; 2a
  .e_res2            resw  10		; 3a
  .e_lfanew          resd      1		; 3c
endstruc

struc IMAGE_BASE_RELOCATION
    .VirtualAddress resd   1
    .SizeOfBlock resd      1
endstruc


struc IMAGE_IMPORT_BY_NAME
    .Hint resw     1
    .Name1 resb    1
endstruc

struc IMAGE_THUNK_DATA32
	.ThunkData resd 1
endstruc

IMAGE_THUNK_DATA EQU IMAGE_THUNK_DATA32
;IMAGE_TLS_DIRECTORY EQU IMAGE_TLS_DIRECTORY32

struc IMAGE_IMPORT_DESCRIPTOR
    .OriginalFirstThunk resd   1
    .IMPORT_TimeDateStamp resd		1
    .ForwarderChain resd		1
    .IMPORT_Name1 resd				1
    .FirstThunk resd			1
endstruc

struc IMAGE_BOUND_IMPORT_DESCRIPTOR
    .TimeDateStamp	resd    1
    .OffsetModuleName resw 1
    .NumberOfModuleForwarderRefs resw 1
endstruc

IMAGE_SIZEOF_SHORT_NAME equ 8

struc IMAGE_SECTION_HEADER
    .SECT_Name1 resb 		IMAGE_SIZEOF_SHORT_NAME ; resb IMAGE_SIZEOF_SHORT_NAME dup(1)		; 00
    .VirtualSize resd      1			; 08
    .VirtualAddress resd       1		; 0C
    .SizeOfRawData resd        1		; 10
    .PointerToRawData resd     1		; 14
    .PointerToRelocations resd 1		; 18
    .PointerToLinenumbers resd 1		; 1c
    .NumberOfRelocations resw  1		; 1e
    .NumberOfLinenumbers resw  1		; 20
    .SECTION_Characteristics resd      1	; 24
endstruc

IMAGE_SIZEOF_SECTION_HEADER equ 40

struc PEInfo
	.hPEFile				resd 1		; 00
	.hMappedFile			resd 1		; 04
	.FileBase			resd 1		; 08
	.ImageDosHeader		resd 1		; 0c
	.ImageNtHeaders		resd 1		; 10
	.ImageFileHeader		resd 1		; 14
	.ImageOptionalHeader	resd 1		; 18
endstruc

struc AppendFile
	.signature		resd 1		; 00
	.fileName		resb 16		; 04
	.fileSize		resd 1		; 14
	.packFileSize	resd 1		; 18
endstruc

struc LoaderInfo
	.pPEInfo				resd 1
	.OriginalRelocRVA	resd 1
	.CurrentOffset		resd 1
	.OriginalITRVA		resd 1
	.OriginalETRVA		resd 1
	.TextRVA				resd 1
	.TextSize			resd 1
	.DataRVA				resd 1
	.DataSize			resd 1
	.RDataRVA			resd 1
	.RDataSize			resd 1
	.Imports				resd 1
endstruc

struc StartupInfo
	.cb	resd 1
	.lpReserved	resd 1
	.lpDesktop	resd 1
	.lpTitle		resd 1
	.dwX			resd 1
	.dwY			resd 1
	.dwXSize		resd 1
	.dwYSize		resd 1
	.dwXCountChars	resd 1
	.dwYCountChars	resd 1
	.dwFillAttribute	resd 1
	.dwFlags			resd 1
	.wShowWindow		resw 1
	.cbReserved2		resw 1
	.lpReserved2		resd 1
	.hStdInput		resd 1
	.hStdOutput		resd 1
	.hStdError		resd 1
endstruc

struc PROCESS_INFORMATION
	.hProcess	resd 1
	.hThread		resd 1
	.dwProcessId	resd 1
	.dwThreadId	resd 1
endstruc

