%macro gen_instr 6
	;	%1	instr
	;	%2	op1
	;	%3	op2
	;	%4	function
	;	%5	instrLabel
	;	%6	base:=<esi+28>
	
	%ifdef DEBUG_PROTO
		%ifidni %3, SKIP
			%1			%2
		%else
			%1			%2, %3
		%endif
	%else
		%ifidni %5, SKIP
			; NOP
		%else
			%5:
		%endif
			push		eax
			mov			eax, %6
			pushfd
			add			eax, ($ - %4) + (5 + 2 + 2 + (%%2 + 2 - %%1))
			popfd
			jmp			eax
		%%1:
			;db 0C7h, 044h
			db 90h, 90h
			pop			eax
		
		%ifidni %3, SKIP
			%1			%2
		%else
			%1			%2, %3
		%endif
		
		push			ecx
		mov 			ecx, %6
		pushfd
		add 			ecx, ($ - %4) + (6 + 2 + 2 + (%%3 - %%2 + 2))
		popfd
		jmp ecx
%%2:
		;db 0C7h
		db 90h, 90h
		;db 44h
		jmp %%1+2
%%3:
		;db 0C7h
		;db 44h
		db 90h, 90h
		pop ecx
	%endif
%endmacro

%macro seh_called 0
	pop dword [fs:0]
	add esp, 4
	popad
%endmacro

%macro setup_obfuscation 1
		call 	%%1
	%%1:
		pop		ebp
		sub		ebp, $ - %1 - 1
		mov		dword [esi+28h], ebp
%endmacro
	
%macro gen_instr2 4
	; Create a label
	%ifidni %4,	SKIP
		; NOP
	%else
		%4:
	%endif

	%ifdef DEBUG_PROTO
		%ifidni %3, SKIP
			%ifidni %2, SKIP
				%1
			%else
				%1 %2
			%endif
		%else
			; Assemble INSTR, op1, op2
			%1 %2, %3
		%endif
	%else
			push ecx
			call %%5
			;db 0C7h
			;db 44h
			db 90h, 90h
			pop ecx

		%ifidni %3, SKIP
			%ifidni %2, SKIP
				%1
			%else
				%1 %2
			%endif
		%else
			; Assemble INSTR, op1, op2
			%1 %2, %3
		%endif
			push eax
			call %%6
		%%6:
			pop eax
			pushfd
			dec eax
			add eax, (%%7+2) - %%6
			popfd
			jmp eax
		%%5:
			pop ecx
			pushfd
			add ecx, 2
			popfd
			jmp ecx
		%%7:
			;db 35h
			pop eax
	%endif
%endmacro

; calls a function using SEH
;%macro seh_call handler, function, base
%macro seh_call 4
	push %4
	pushad
	mov eax, %3
	add eax, %1 - real_loader_start
	gen_instr2 push, eax, SKIP, SKIP
	gen_instr2 xor, eax, eax, SKIP
	gen_instr2 push, dword [fs:eax], SKIP, SKIP
	gen_instr2 mov, dword [fs:eax], esp, SKIP
	mov edi, %3
	add edi, %2 - real_loader_start
	push edi
	gen_instr2 cpuid, SKIP, SKIP, SKIP
	gen_instr2 rdtsc, SKIP, SKIP, SKIP
	pop edi
	mov ebx, eax
	xor eax, eax
	idiv eax
%endm

%macro seh_debug_handler 3
	push %3
	gen_instr2 add, dword [esp], %%END_SEH - real_loader_start, SKIP
	pushad
	gen_instr2 mov, eax, %3, SKIP
	gen_instr2 add, eax, %1 - real_loader_start, SKIP
	push eax
	xor eax, eax
	gen_instr2 push, dword [fs:eax], SKIP, SKIP
	gen_instr2 mov, dword [fs:eax], esp, SKIP
	gen_instr2 mov, edi, %3, SKIP
	gen_instr2 add, edi, %2 - real_loader_start, SKIP
	gen_instr2 push, edi, SKIP, SKIP
	gen_instr2 pop, edi, SKIP, SKIP
	gen_instr2 mov, ebx, eax, SKIP
	xor eax, eax
	pushfd
	or dword [esp], 100h	; Enable Trace Flag
	popfd		; First Exception :P
	div eax	; Generate second exception ...
%%END_SEH:
%endm

%macro crc_debug_handler 2
	xor eax, eax
	push esi
	pushad
	push %2
	pop esi
	push %2
	add dword [esp], crc_handler - real_loader_start
	push dword [fs:eax]
	mov dword [fs:eax], esp
	jmp %%RAISE_EXCEPT
	db 0fh, 1fh, 80h
	dd 0
	dw %1
%%RAISE_EXCEPT
	idiv eax
%%END_SEH:
	seh_called
	nop
	pop esi
%endm